Attribute VB_Name = "mdlEffects"

Dim EffectsObj As clsSpecialEffects

'Initializes the engine
Public Sub InitialiseSpecialEffects()
    Set EffectsObj = New clsSpecialEffects
    EffectsObj.InitEffects
End Sub

'Applies a special effect to an image
Public Sub SpecialBlt(SourceSurf As DirectDrawSurface7, SourceDesc As DDSURFACEDESC2, DestSurf As DirectDrawSurface7, DestDesc As DDSURFACEDESC2, ByVal dX As Long, ByVal dY As Long, SrcX As Long, SrcY As Long, SrcWid As Long, SrcHgt As Long, LookupTableIndex As Long)
    'First, check if it's a valid effect!
    If LookupTableIndex < 0 Or LookupTableIndex > 17 Then
        'It's not a valid effect, so don't use one
        Exit Sub
    End If
    
    'On Error GoTo ErrHandler
    
    'This piece of code will deal with half-cut images...
    Dim SrcRect As RECT
    With SrcRect
    'Left
    If dX <= 0 Then
        .Left = -dX + SrcX
        dX = 0
    Else
        .Left = SrcX
    End If
    'Top
    If dY <= 0 Then
        .Top = -dY + SrcY
        dY = 0
    Else
        .Top = SrcY
    End If
    'Right
    If dX + SrcWid > ScreenX Then
        .Right = SrcX + SrcWid - ((dX + SrcWid) - ScreenX)
    Else
        .Right = SrcX + SrcWid
    End If
    'Bottom
    If dY + SrcHgt > ScreenY Then
        .Bottom = SrcY + SrcHgt - ((dY + SrcHgt) - ScreenY)
    Else
        .Bottom = SrcY + SrcHgt
    End If
    End With
    
    'Get an array from each of the surfaces
    Dim EmptyRect As RECT
    Dim SrcArray() As Byte, DestArray() As Byte
    SourceSurf.Lock EmptyRect, SourceDesc, DDLOCK_NOSYSLOCK Or DDLOCK_WAIT, 0
    SourceSurf.GetLockedArray SrcArray()
    DestSurf.Lock EmptyRect, DestDesc, DDLOCK_NOSYSLOCK Or DDLOCK_WAIT, 0
    DestSurf.GetLockedArray DestArray()
    
    'This is because each pixel occupies 3 elements in the array, horizontally
    '(for the RGB values)
    dX = dX * 3
    SrcRect.Left = SrcRect.Left * 3
    SrcRect.Right = SrcRect.Right * 3
    
    'Loop trough all pixels and set them
    EffectsObj.SpecialBltArray SrcArray(), DestArray(), dX, dY, SrcRect.Left, SrcRect.Top, _
      SrcRect.Right - SrcRect.Left - 1, SrcRect.Bottom - SrcRect.Top - 1, LookupTableIndex
    
    'ALWAYS remember to unlock the surfaces!
ErrHandler:
    On Error Resume Next
    'Unlock the surfaces (IMPORTANT)
    SourceSurf.Unlock EmptyRect
    DestSurf.Unlock EmptyRect
End Sub
